<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>

<body>

    <script>
        /* 
            Faça um algoritmo que resolva a função de fibonnaci
            Fibonnaci: https://pt.wikipedia.org/wiki/Sequ%C3%AAncia_de_Fibonacci
        */
        function fib(values) {
            // implementar logica aqui
            function fibMemo(numb, memo) {
                let [a, b] = memo;
                let c = a + b;
                if (numb == 0) {
                    return c;
                } else {
                    memo = [b, c];
                    return fibMemo(numb - 1, memo);
                }
            }

            if(values <= 0){
                return 0;
            }

            if (values < 2) {
                return 1;
            } else {
                return fibMemo(values - 2, [0, 1]);
            }
        }

        // Resultados esperados
        console.log(fib(0), 0) // 0
        console.log(fib(1), 1) // 1
        console.log(fib(2), 1) // 1
        console.log(fib(3), 2) // 2
        console.log(fib(4), 3) // 3
        console.log(fib(5), 5) // 5
        console.log(fib(35), 9227465) // 9227465
        console.log(fib(46), 1836311903) // 1836311903

    </script>
</body>

</html>